﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ClothingSizeIdentificationUsingKinect
{
    public abstract class ClothingSize
    {
        public abstract string TshirtSize(double width, double height);
        public abstract string PantsSize(double length, double waist);
    }

    public class MaleSize : ClothingSize
    {
        public override string TshirtSize(double width, double height)
        {
            if (width > 54 || height > 66) {
                return "XL";
            }
            else if (width > 50 || height > 64) {
                return "L";
            }
            else if (width > 50 || height > 60)
            {
                return "M";
            }
            else if (width < 50 || height < 60)
            {
                return "S";
            }
            else {
                return "N/A";
            }
        }

        public override string PantsSize(double length, double waist)
        {
            if (length > 115 || waist > 103)
            {
                return "38";
            }
            else if (length > 112 || waist > 97)
            {
                return "36";
            }
            else if (length > 106 || waist > 90)
            {
                return "34b";
            }
            else if (length > 100 || waist > 78)
            {
                return "34a";
            }
            else if (length < 100 || waist < 78)
            {
                return "30";
            }
            else
            {
                return "N/A";
            }
        }
    }

    public class FemaleSize : ClothingSize
    {
        public override string TshirtSize(double width, double height)
        {
            if (width > 48 || height > 58)
            {
                return "XL";
            }
            else if (width > 41 || height > 56)
            {
                return "L";
            }
            else if (width > 41 || height > 52)
            {
                return "M";
            }
            else if (width < 39 || height < 52)
            {
                return "S";
            }
            else
            {
                return "N/A";
            }
        }

        public override string PantsSize(double length, double waist)
        {
            if (length > 106 || waist > 90)
            {
                return "36";
            }
            else if (length > 100 || waist > 83)
            {
                return "34";
            }
            else if (length < 90 || waist < 78)
            {
                return "30";
            }
            else if (length < 80 || waist < 70)
            {
                return "29";
            }
            else if (length < 80 || waist < 66)
            {
                return "26";
            }
            else
            {
                return "N/A";
            }
        }
    }
}


